using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

using Org.Mentalis.Utilities;

namespace TimerComputerShutdown
{
	/// <summary>
	/// Summary description for TimerComputerShutdown.
	/// </summary>
	public class TimerComputerShutdown : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelWhatDoYouWantTheComputerToDo;
		private System.Windows.Forms.ComboBox comboBox;
		private System.Windows.Forms.Label labelSelectDateTimeToShutdownComputer;
		private System.Windows.Forms.DateTimePicker dateTimePicker;
		private System.Windows.Forms.Label labelDateTimeNow;
		private System.Windows.Forms.Label labelDateTimeShutdown;
		private System.Windows.Forms.Label labelNow;
		private System.Windows.Forms.Label labelShutdown;
		private System.Windows.Forms.Panel panelParent;
		private System.Windows.Forms.Panel panelChild;
		private System.Windows.Forms.CheckBox checkBox;
		private System.Windows.Forms.Button buttonAbout; 
		private System.Windows.Forms.Button buttonCancel;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.Label date;
		private System.Windows.Forms.Button buttonInvoke;
		//private System.Threading.Thread thread;
		//private System.Threading.ThreadStart threadStart;
		private System.Windows.Forms.NotifyIcon notifyIcon;

		[DllImport("user32.dll")] private static extern 
			bool SetForegroundWindow(IntPtr hWnd);
		[DllImport("user32.dll")] private static extern 
			bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);
		[DllImport("user32.dll")] private static extern 
			bool IsIconic(IntPtr hWnd);

		private const int SW_HIDE = 0;
		private const int SW_SHOWNORMAL = 1;
		private const int SW_SHOWMINIMIZED = 2;
		private const int SW_SHOWMAXIMIZED = 3;
		private const int SW_SHOWNOACTIVATE = 4;
		private const int SW_RESTORE = 9;
		private const int SW_SHOWDEFAULT = 10;
		
		public TimerComputerShutdown()
		{
			//
			// Required for Windows Form Designer support
			//
			this.timer1 = new System.Windows.Forms.Timer();

			InitializeComponent();
			
			comboBox.SelectedIndex=0;

			notifyIcon = new NotifyIcon();
			notifyIcon.Text = this.Text;
			notifyIcon.Icon = this.Icon;
			notifyIcon.Click += new System.EventHandler(this.NotifyIcon_Click);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TimerComputerShutdown));
			this.labelWhatDoYouWantTheComputerToDo = new System.Windows.Forms.Label();
			this.comboBox = new System.Windows.Forms.ComboBox();
			this.labelSelectDateTimeToShutdownComputer = new System.Windows.Forms.Label();
			this.dateTimePicker = new System.Windows.Forms.DateTimePicker();
			this.labelDateTimeNow = new System.Windows.Forms.Label();
			this.labelDateTimeShutdown = new System.Windows.Forms.Label();
			this.labelNow = new System.Windows.Forms.Label();
			this.labelShutdown = new System.Windows.Forms.Label();
			this.panelParent = new System.Windows.Forms.Panel();
			this.panelChild = new System.Windows.Forms.Panel();
			this.buttonAbout = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.checkBox = new System.Windows.Forms.CheckBox();
			this.buttonInvoke = new System.Windows.Forms.Button();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.date = new System.Windows.Forms.Label();
			this.panelParent.SuspendLayout();
			this.panelChild.SuspendLayout();
			this.SuspendLayout();
			// 
			// labelWhatDoYouWantTheComputerToDo
			// 
			this.labelWhatDoYouWantTheComputerToDo.BackColor = System.Drawing.Color.Transparent;
			this.labelWhatDoYouWantTheComputerToDo.ForeColor = System.Drawing.Color.White;
			this.labelWhatDoYouWantTheComputerToDo.Location = new System.Drawing.Point(8, 6);
			this.labelWhatDoYouWantTheComputerToDo.Name = "labelWhatDoYouWantTheComputerToDo";
			this.labelWhatDoYouWantTheComputerToDo.Size = new System.Drawing.Size(216, 24);
			this.labelWhatDoYouWantTheComputerToDo.TabIndex = 9;
			this.labelWhatDoYouWantTheComputerToDo.Text = "What do you want the computer to do?:";
			this.labelWhatDoYouWantTheComputerToDo.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// comboBox
			// 
			this.comboBox.Cursor = System.Windows.Forms.Cursors.Hand;
			this.comboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBox.Items.AddRange(new object[] {
														  "Shutdown",
														  "Restart",
														  "Stand By",
														  "Hibernate",
														  "Log Off"});
			this.comboBox.Location = new System.Drawing.Point(286, 8);
			this.comboBox.Name = "comboBox";
			this.comboBox.Size = new System.Drawing.Size(80, 21);
			this.comboBox.TabIndex = 0;
			this.comboBox.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
			// 
			// labelSelectDateTimeToShutdownComputer
			// 
			this.labelSelectDateTimeToShutdownComputer.BackColor = System.Drawing.Color.Transparent;
			this.labelSelectDateTimeToShutdownComputer.ForeColor = System.Drawing.Color.White;
			this.labelSelectDateTimeToShutdownComputer.Location = new System.Drawing.Point(8, 44);
			this.labelSelectDateTimeToShutdownComputer.Name = "labelSelectDateTimeToShutdownComputer";
			this.labelSelectDateTimeToShutdownComputer.Size = new System.Drawing.Size(192, 24);
			this.labelSelectDateTimeToShutdownComputer.TabIndex = 7;
			this.labelSelectDateTimeToShutdownComputer.Text = "Select Date/Time to Shutdown: ";
			this.labelSelectDateTimeToShutdownComputer.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// dateTimePicker
			// 
			this.dateTimePicker.CalendarFont = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dateTimePicker.Cursor = System.Windows.Forms.Cursors.Hand;
			this.dateTimePicker.CustomFormat = "6:30:00 dd-MM-yyyy";
			this.dateTimePicker.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dateTimePicker.Format = System.Windows.Forms.DateTimePickerFormat.Time;
			this.dateTimePicker.Location = new System.Drawing.Point(286, 46);
			this.dateTimePicker.Name = "dateTimePicker";
			this.dateTimePicker.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.dateTimePicker.Size = new System.Drawing.Size(80, 21);
			this.dateTimePicker.TabIndex = 1;
			this.dateTimePicker.Value = new System.DateTime(2004, 1, 22, 0, 0, 0, 0);
			this.dateTimePicker.ValueChanged += new System.EventHandler(this.dateTimePicker_ValueChanged);
			// 
			// labelDateTimeNow
			// 
			this.labelDateTimeNow.BackColor = System.Drawing.Color.GhostWhite;
			this.labelDateTimeNow.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelDateTimeNow.ForeColor = System.Drawing.Color.DarkBlue;
			this.labelDateTimeNow.Location = new System.Drawing.Point(8, 8);
			this.labelDateTimeNow.Name = "labelDateTimeNow";
			this.labelDateTimeNow.Size = new System.Drawing.Size(120, 16);
			this.labelDateTimeNow.TabIndex = 4;
			this.labelDateTimeNow.Text = "Date/Time now:";
			this.labelDateTimeNow.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// labelDateTimeShutdown
			// 
			this.labelDateTimeShutdown.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelDateTimeShutdown.ForeColor = System.Drawing.Color.DarkBlue;
			this.labelDateTimeShutdown.Location = new System.Drawing.Point(8, 32);
			this.labelDateTimeShutdown.Name = "labelDateTimeShutdown";
			this.labelDateTimeShutdown.Size = new System.Drawing.Size(120, 16);
			this.labelDateTimeShutdown.TabIndex = 5;
			this.labelDateTimeShutdown.Text = "Date/Time Shutdown:";
			this.labelDateTimeShutdown.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// labelNow
			// 
			this.labelNow.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelNow.ForeColor = System.Drawing.Color.DarkBlue;
			this.labelNow.Location = new System.Drawing.Point(136, 8);
			this.labelNow.Name = "labelNow";
			this.labelNow.Size = new System.Drawing.Size(136, 16);
			this.labelNow.TabIndex = 1;
			this.labelNow.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelShutdown
			// 
			this.labelShutdown.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelShutdown.ForeColor = System.Drawing.Color.DarkBlue;
			this.labelShutdown.Location = new System.Drawing.Point(136, 32);
			this.labelShutdown.Name = "labelShutdown";
			this.labelShutdown.Size = new System.Drawing.Size(136, 16);
			this.labelShutdown.TabIndex = 8;
			this.labelShutdown.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// panelParent
			// 
			this.panelParent.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panelParent.Controls.Add(this.panelChild);
			this.panelParent.Location = new System.Drawing.Point(41, 74);
			this.panelParent.Name = "panelParent";
			this.panelParent.Size = new System.Drawing.Size(288, 60);
			this.panelParent.TabIndex = 6;
			// 
			// panelChild
			// 
			this.panelChild.Controls.Add(this.labelNow);
			this.panelChild.Controls.Add(this.labelShutdown);
			this.panelChild.Controls.Add(this.labelDateTimeShutdown);
			this.panelChild.Controls.Add(this.labelDateTimeNow);
			this.panelChild.Location = new System.Drawing.Point(0, 0);
			this.panelChild.Name = "panelChild";
			this.panelChild.Size = new System.Drawing.Size(280, 56);
			this.panelChild.TabIndex = 8;
			// 
			// buttonAbout
			// 
			this.buttonAbout.BackColor = System.Drawing.Color.Transparent;
			this.buttonAbout.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonAbout.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonAbout.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.buttonAbout.Location = new System.Drawing.Point(8, 154);
			this.buttonAbout.Name = "buttonAbout";
			this.buttonAbout.Size = new System.Drawing.Size(64, 23);
			this.buttonAbout.TabIndex = 5;
			this.buttonAbout.Text = "&About";
			this.buttonAbout.Click += new System.EventHandler(this.buttonAbout_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.BackColor = System.Drawing.Color.Transparent;
			this.buttonCancel.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonCancel.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonCancel.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.buttonCancel.Location = new System.Drawing.Point(302, 154);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.Size = new System.Drawing.Size(64, 23);
			this.buttonCancel.TabIndex = 4;
			this.buttonCancel.Text = "&Exit";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// checkBox
			// 
			this.checkBox.BackColor = System.Drawing.Color.Transparent;
			this.checkBox.Cursor = System.Windows.Forms.Cursors.Hand;
			this.checkBox.ForeColor = System.Drawing.Color.White;
			this.checkBox.Location = new System.Drawing.Point(144, 153);
			this.checkBox.Name = "checkBox";
			this.checkBox.Size = new System.Drawing.Size(56, 24);
			this.checkBox.TabIndex = 2;
			this.checkBox.Text = "&Brute";
			this.checkBox.CheckedChanged += new System.EventHandler(this.checkBox_CheckedChanged);
			// 
			// buttonInvoke
			// 
			this.buttonInvoke.BackColor = System.Drawing.Color.Transparent;
			this.buttonInvoke.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonInvoke.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.buttonInvoke.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.buttonInvoke.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.buttonInvoke.Location = new System.Drawing.Point(224, 154);
			this.buttonInvoke.Name = "buttonInvoke";
			this.buttonInvoke.Size = new System.Drawing.Size(64, 23);
			this.buttonInvoke.TabIndex = 10;
			this.buttonInvoke.Text = "&Invoke";
			this.buttonInvoke.Click += new System.EventHandler(this.buttonInvoke_Click);
			// 
			// timer1
			// 
			this.timer1.Interval = 500;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// date
			// 
			this.date.BackColor = System.Drawing.Color.Transparent;
			this.date.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.date.ForeColor = System.Drawing.Color.White;
			this.date.Location = new System.Drawing.Point(202, 44);
			this.date.Name = "date";
			this.date.Size = new System.Drawing.Size(80, 24);
			this.date.TabIndex = 11;
			this.date.Text = "Today";
			this.date.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// TimerComputerShutdown
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.BackColor = System.Drawing.Color.GhostWhite;
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(370, 181);
			this.Controls.Add(this.date);
			this.Controls.Add(this.buttonInvoke);
			this.Controls.Add(this.checkBox);
			this.Controls.Add(this.comboBox);
			this.Controls.Add(this.labelWhatDoYouWantTheComputerToDo);
			this.Controls.Add(this.buttonAbout);
			this.Controls.Add(this.panelParent);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.dateTimePicker);
			this.Controls.Add(this.labelSelectDateTimeToShutdownComputer);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "TimerComputerShutdown";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Timer Computer Shutdown DaF\'s Build";
			this.TopMost = true;
			this.Resize += new System.EventHandler(this.TimerComputerShutdown_Resize);
			this.Load += new System.EventHandler(this.TimerComputerShutdown_Load);
			this.panelParent.ResumeLayout(false);
			this.panelChild.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			#region VisualStyles Bits
			/*
			 * The first call enables Visual Styles (WinXp only)
			 * and the second one prevents some possible issues
			 * with the way the .NET Framework Handles the Visual
			 * Styles.
			 * 
			 * Notes:
			 * Controls with FlatStyle property should be set to
			 * System.
			 * 
			 * See http://blogs.msdn.com/rprabhu/archive/2003/09/28/56540.aspx
			 * for more info.
			*/
			Application.EnableVisualStyles();
			Application.DoEvents();
			#endregion

			Application.Run(new TimerComputerShutdown());
		}

		private void TimerComputerShutdown_Load(object sender, System.EventArgs e)
		{
			this.panelChild.Visible = false;

			this.dateTimePicker.Value = System.DateTime.Now;
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			timer1.Stop();
			System.Windows.Forms.Application.Exit();

			base.OnClosing(e);
		}

		public void Computer_Shutdown()
		{
			if (this.checkBox.Checked)
			{
				System.Diagnostics.Process[] processes = System.Diagnostics.Process.GetProcesses();

				foreach (System.Diagnostics.Process processParent in processes)
				{
					System.Diagnostics.Process[] processNames = System.Diagnostics.Process.GetProcessesByName(processParent.ProcessName);
	
					foreach (System.Diagnostics.Process processChild in processNames)
					{
						try
						{
							System.IntPtr hWnd = processChild.MainWindowHandle;
							
							if (IsIconic(hWnd))
							{
								ShowWindowAsync(hWnd, SW_RESTORE);
							}
					
							SetForegroundWindow(hWnd);
							
							if (!(processChild.MainWindowTitle.Equals(this.Text)))
							{
								processChild.CloseMainWindow();
								processChild.Kill();
								processChild.WaitForExit();
							}
						}
						catch (System.Exception exception)
						{

						}
					}
				}
			}

			System.Windows.Forms.Application.Exit();

			switch (this.comboBox.SelectedIndex)
			{
				case 0:
					Org.Mentalis.Utilities.WindowsController.ExitWindows(RestartOptions.PowerOff, false);
					break;
				case 1:
					Org.Mentalis.Utilities.WindowsController.ExitWindows(RestartOptions.Reboot, false);
					break;
				case 2:
					Org.Mentalis.Utilities.WindowsController.ExitWindows(RestartOptions.Suspend, false);
					break;
				case 3:
					Org.Mentalis.Utilities.WindowsController.ExitWindows(RestartOptions.Hibernate, false);
					break;
				case 4:
					Org.Mentalis.Utilities.WindowsController.ExitWindows(RestartOptions.LogOff, false);
					break;
			}
		}
		
		private void comboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			this.labelSelectDateTimeToShutdownComputer.Text = "Select Date/Time to" + " " + this.comboBox.SelectedItem.ToString() + ":";
			this.labelDateTimeShutdown.Text = "Date/Time" + " " + this.comboBox.SelectedItem.ToString() + ":";
		}

		private void checkBox_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.checkBox.Checked)
			{
				Warning warning = new Warning();
				warning.ShowDialog();
			}
		}

		public bool dateTimePicker_Validated()
		{
			if (this.dateTimePicker.Value.CompareTo(System.DateTime.Now) < 0)
			{
				Error error = new Error();
				error.ShowDialog();

				this.dateTimePicker.Value = System.DateTime.Now;

				return false;
			}
			else
			{
				return true;
			}
		}

		private void dateTimePicker_ValueChanged(object sender, System.EventArgs e)
		{
			this.labelShutdown.Text = this.dateTimePicker.Value.ToString();
			this.date.Text = this.dateTimePicker.Value.ToShortDateString();
		}

		private void timer1_Tick(object sender,  System.EventArgs e)
		{
			if (!(this.labelNow.Text.ToString().Equals(this.dateTimePicker.Value.ToString())))
			{
				this.labelNow.Text = System.DateTime.Now.ToString();
			}
			else
			{
				this.Computer_Shutdown();
				
			}
		} 

		private void buttonAbout_Click(object sender, System.EventArgs e)
		{
			About about = new About();

			about.ShowDialog();
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			timer1.Stop();
			System.Windows.Forms.Application.Exit();
		}
		
		private void buttonInvoke_Click(object sender, System.EventArgs e)
		{
			if (this.buttonInvoke.Text.Equals("&Invoke"))
			{
				if (this.dateTimePicker_Validated())
				{
					if (!this.timer1.Enabled)
						this.timer1.Start();

					this.comboBox.Enabled = false;
					this.dateTimePicker.Enabled = false;
					this.panelChild.Visible = true;
					this.buttonInvoke.Text = "&Uninvoke";
					//this.notifyIcon.Text = this.comboBox.SelectedValue + " " + this.dateTimePicker.Value; 
				}
			}
			else if (this.buttonInvoke.Text.Equals("&Uninvoke"))
			{
				timer1.Stop();

				this.comboBox.Enabled = true;
				this.dateTimePicker.Enabled = true;
				this.panelChild.Visible = false;
				this.buttonInvoke.Text = "&Invoke";
			}
		}


		/*
		 *  Addicions By DaF [ daf.public@madalien.com ]
		 *
		 */

		private void NotifyIcon_Click(object sender, System.EventArgs e)
		{
			this.Show();
			this.WindowState = FormWindowState.Normal;
			notifyIcon.Visible = false;
		}

		private void TimerComputerShutdown_Resize(object sender, System.EventArgs e)
		{
			if( this.WindowState == FormWindowState.Minimized)
			{
				notifyIcon.Visible = true;
				this.Hide();
			}
		}
	}
}
